package rg.digit;
/*	
 Curve digitization package

	Copyright Renaud Gicquel 2008
	This document is licensed under CC BY-SA 4.0 (Attribution-ShareAlike 4.0 International)
	
*/
//package rg.digit;
import javax.swing.*;
import java.awt.*;
import java.io.*;

public class Digitaliseur extends javax.swing.JFrame
{
    ImageIcon im;
    double yScale,xScale;
    int xOrigin,yOrigin,xMax,yMax,xMouse,yMouse,nb_points;
	String tab=new String("\t");
	String ligne=new String("\n");
	String[] reference=new String[2000];
	double[] xpoint= new double[2000];
	double[] ypoint= new double[2000];
	boolean isEntering=false;
	JPanel p=new JPanel();
	javax.swing.JScrollPane JScrollPane1 ;
	javax.swing.JButton image = new javax.swing.JButton();
    KeyStroke delKey = KeyStroke.getKeyStroke("DELETE");
    KeyStroke ctrlZ = KeyStroke.getKeyStroke("control Z");


	public Digitaliseur()
	{
		//{{INIT_CONTROLS
		setJMenuBar(JMenuBar1);
		JMenu1.setText("Digitization ");
		JMenu1.setActionCommand("Digitalisation");
		JMenuBar1.add(JMenu1);
		JMenu1.setText("Actions");
		JMenu1.setActionCommand("Actions");
		JMenuBar1.add(JMenu1);
		deleteItem.setText("Cancel");
		deleteItem.setActionCommand("Cancel");
		JMenu1.add(deleteItem);
        deleteItem.setAccelerator(ctrlZ);
		getContentPane().setLayout(null);
		setSize(1180,700);
		setVisible(false);
		bLoad.setText("Load image");
		bLoad.setActionCommand("Load");
		getContentPane().add(bLoad);
		bLoad.setBounds(960,360,142,48);
		getContentPane().add(ymin_value);
		ymin_value.setBounds(1020,48,96,24);
		JLabel1.setText("Y min");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(960,48,72,24);
		JLabel2.setText("Y max");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(972,216,72,36);
		getContentPane().add(ymax_value);
		ymax_value.setBounds(1032,228,96,24);
		JLabel3.setText("X max");
		getContentPane().add(JLabel3);
		JLabel3.setBounds(960,132,72,36);
		getContentPane().add(xmax_value);
		xmax_value.setBounds(1020,144,96,24);
		JLabel4.setText("X min");
		getContentPane().add(JLabel4);
		JLabel4.setBounds(960,12,72,24);
		getContentPane().add(xmin_value);
		xmin_value.setBounds(1020,12,96,24);
		bsetYmax.setText("Set Ymax");
		bsetYmax.setActionCommand("setScale");
		getContentPane().add(bsetYmax);
		bsetYmax.setBounds(984,264,137,36);
		bsetXmax.setText("Set Xmax");
		bsetXmax.setActionCommand("setScale");
		getContentPane().add(bsetXmax);
		bsetXmax.setBounds(984,180,137,36);
		bsetXmin.setText("Set origin");
		bsetXmin.setActionCommand("setScale");
		getContentPane().add(bsetXmin);
		bsetXmin.setBounds(984,84,137,36);
		mouseLabel.setText("current point");
		getContentPane().add(mouseLabel);
		mouseLabel.setBounds(960,600,141,24);
		bEnterPoint.setText("Start digitazing");
		bEnterPoint.setActionCommand("New  point");
		getContentPane().add(bEnterPoint);
		bEnterPoint.setBounds(948,552,147,43);
		bSavePoints.setText("Save points");
		bSavePoints.setActionCommand("Save Points");
		getContentPane().add(bSavePoints);
		bSavePoints.setForeground(java.awt.Color.red);
		bSavePoints.setBounds(960,420,147,38);
		getContentPane().add(reference_value);
		reference_value.setBounds(948,516,151,23);
		JLabel5.setText("reference");
		getContentPane().add(JLabel5);
		JLabel5.setBounds(948,492,137,17);
		labOrigin.setText("origin");
		getContentPane().add(labOrigin);
		labOrigin.setBounds(948,120,169,23);
		labMax.setText("max values");
		getContentPane().add(labMax);
		labMax.setBounds(960,312,144,24);
		labPoints.setText("number of points");
		getContentPane().add(labPoints);
		labPoints.setBounds(960,468,132,24);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bLoad.addActionListener(lSymAction);
		deleteItem.addActionListener(lSymAction);
		SymMouse aSymMouse = new SymMouse();
		image.addMouseListener(aSymMouse);
		bsetYmax.addActionListener(lSymAction);
		bsetXmax.addActionListener(lSymAction);
		bsetXmin.addActionListener(lSymAction);
		bEnterPoint.addActionListener(lSymAction);
		bSavePoints.addActionListener(lSymAction);
		ymin_value.addMouseListener(aSymMouse);
		ymax_value.addMouseListener(aSymMouse);
		xmax_value.addMouseListener(aSymMouse);
		xmin_value.addMouseListener(aSymMouse);
		//}}

		//{{INIT_MENUS
		//}}
        im=new ImageIcon(System.getProperty("user.dir")+File.separator+"compresseur.jpg");
        nb_points=-1;
		p.setSize(2000,1000);
		p.setLayout(new GridLayout());
		image.setText("");
		image.setActionCommand("image");
		image.setBounds(0,0,2000,1000);
		p.add(image);
	    JScrollPane1 = new javax.swing.JScrollPane(p);

		JScrollPane1.setBounds(0,0,932,640);
		setTitle("Curve digitization package");
		JScrollPane1.createHorizontalScrollBar();
		JScrollPane1.createVerticalScrollBar();
		JScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		JScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		getContentPane().add(JScrollPane1, BorderLayout.CENTER);
	}

	public Digitaliseur(String title)
	{
		this();
		setTitle(title);
	}
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == Digitaliseur.this)
			Digitaliseur_WindowClosing(event);
		}
	}

	void Digitaliseur_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JButton bLoad = new javax.swing.JButton();
	DoubleChamp ymin_value = new DoubleChamp();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	DoubleChamp ymax_value = new DoubleChamp();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	DoubleChamp xmax_value = new DoubleChamp();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	DoubleChamp xmin_value = new DoubleChamp();
	javax.swing.JMenuBar JMenuBar1 = new javax.swing.JMenuBar();
	javax.swing.JMenu JMenu1 = new javax.swing.JMenu();
	javax.swing.JMenuItem deleteItem = new javax.swing.JMenuItem();
	javax.swing.JButton bsetYmax = new javax.swing.JButton();
	javax.swing.JButton bsetXmax = new javax.swing.JButton();
	javax.swing.JButton bsetXmin = new javax.swing.JButton();
	javax.swing.JLabel mouseLabel = new javax.swing.JLabel();
	javax.swing.JButton bEnterPoint = new javax.swing.JButton();
	javax.swing.JButton bSavePoints = new javax.swing.JButton();
	javax.swing.JTextField reference_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel labOrigin = new javax.swing.JLabel();
	javax.swing.JLabel labMax = new javax.swing.JLabel();
	javax.swing.JLabel labPoints = new javax.swing.JLabel();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bLoad)
				bLoad_actionPerformed(event);
			if (object == deleteItem)
				deleteItem_actionPerformed(event);
			else if (object == bsetYmax)
				bsetYmax_actionPerformed(event);
			if (object == bsetXmax)
				bsetXmax_actionPerformed(event);
			else if (object == bsetXmin)
				bsetXmin_actionPerformed(event);
			else if (object == bEnterPoint)
				bEnterPoint_actionPerformed(event);
			else if (object == bSavePoints)
				bSavePoints_actionPerformed(event);
		}
	}

	void bLoad_actionPerformed(java.awt.event.ActionEvent event)
	{
        FileDialog ff = new FileDialog(this,"Input file",FileDialog.LOAD);
        ff.setDirectory(System.getProperty("user.dir"));
        ff.show();

        String nomfic = ff.getFile();
        String directory=ff.getDirectory();
        im=new ImageIcon(directory+File.separator+nomfic);

		image.setIcon(im);
		if(test)p.setSize(2001, 1001);
		else p.setSize(2000, 1000);
		image.setBounds(0,0,2000,1000);

		test=!test;
	}


	void deleteItem_actionPerformed(java.awt.event.ActionEvent event)
	{
	    nb_points--;
	    if(nb_points<-1)nb_points=-1;
		int i=nb_points+1;
		labPoints.setText("points : "+i);
	}


	boolean test;

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == image)
				image_mouseClicked(event);
			else if (object == ymin_value)
				yminValue_mouseClicked(event);
			else if (object == ymax_value)
				ymaxValue_mouseClicked(event);
			else if (object == xmax_value)
				xmaxValue_mouseClicked(event);
			else if (object == xmin_value)
				xminValue_mouseClicked(event);
		}
	}

	void image_mouseClicked(java.awt.event.MouseEvent event)
	{
		xMouse=event.getX();
		yMouse=event.getY();
		mouseLabel.setText("x= "+xMouse+"  y= "+yMouse);

	    if(isEntering){
		    nb_points++;
		    reference[nb_points]=reference_value.getText();
		    xpoint[nb_points]=(xMouse-xOrigin)*xScale+xmin_value.getValue();
		    ypoint[nb_points]=(yMouse-yOrigin)*yScale+ymin_value.getValue();
		    int i=nb_points+1;
		    labPoints.setText("points : "+i);
		}


	}

	void bsetYmax_actionPerformed(java.awt.event.ActionEvent event)
	{
	    yMax=yMouse;
		yScale=(ymax_value.getValue()-ymin_value.getValue())/(yMax-yOrigin);
		ymax_value.setEnabled(false);
		System.out.println("yMax : "+"\t"+yMax+" yScale : "+"\t"+yScale);
		labMax.setText("xMax : "+xMax+"  / yMax : "+yMax);
	}

	void bsetXmax_actionPerformed(java.awt.event.ActionEvent event)
	{
	    xMax=xMouse;
		xScale=(xmax_value.getValue()-xmin_value.getValue())/(xMax-xOrigin);
		xmax_value.setEnabled(false);
		System.out.println("xMax : "+"\t"+xMax+" xScale : "+"\t"+xScale);
		labMax.setText("xMax : "+xMax+"  / yMax : "+yMax);
	}

	void bsetXmin_actionPerformed(java.awt.event.ActionEvent event)
	{
	    xOrigin=xMouse;
		xScale=(xmax_value.getValue()-xmin_value.getValue())/(xMax-xOrigin);
		xmin_value.setEnabled(false);
		System.out.println("xOrigin : "+"\t"+xOrigin+" xScale : "+"\t"+xScale);
	    yOrigin=yMouse;
		yScale=(ymax_value.getValue()-ymin_value.getValue())/(yMax-yOrigin);
		ymin_value.setEnabled(false);
		System.out.println("yOrigin : "+"\t"+yOrigin+" yScale : "+"\t"+yScale);
		labOrigin.setText("xOrigin : "+xOrigin+"  / yOrigin : "+yOrigin);
	}

	void savePoints(){
        try{
            File fich2=new File("curve.txt");
	        FileWriter out = new FileWriter(fich2);
	        char[]data = new char[1000];
	        String h =new String();
	        h="Digitized curve"+ligne;
	        h = h+"number of points"+ligne
	        +nb_points+ligne;

			for(int i=0 ;i<nb_points;i++){
			    h=h+reference[i]+tab+xpoint[i]+tab+ypoint[i];
			    h=h+ligne;
			}

	        data=h.toCharArray();
	        int data_length=h.length();
	        out.write(data,0,data_length);
	        out.flush();
	        out.close();
        }
        catch(Exception e){System.out.println(e);}
    }


	void bEnterPoint_actionPerformed(java.awt.event.ActionEvent event)
	{
	    isEntering=!isEntering;
	    if(isEntering)bEnterPoint.setText("Stop digitazing");
	    else bEnterPoint.setText("Start digitazing");

	}

	void bSavePoints_actionPerformed(java.awt.event.ActionEvent event)
	{
		savePoints();

	}

	void yminValue_mouseClicked(java.awt.event.MouseEvent event)
	{
	    if(event.getClickCount()==2)ymin_value.setEnabled(!ymin_value.isEnabled());
	}

	void ymaxValue_mouseClicked(java.awt.event.MouseEvent event)
	{
	    if(event.getClickCount()==2)ymax_value.setEnabled(!ymax_value.isEnabled());
	}

	void xmaxValue_mouseClicked(java.awt.event.MouseEvent event)
	{
	    if(event.getClickCount()==2)xmax_value.setEnabled(!xmax_value.isEnabled());
	}

	void xminValue_mouseClicked(java.awt.event.MouseEvent event)
	{
	    if(event.getClickCount()==2)xmin_value.setEnabled(!xmin_value.isEnabled());
	}
}