package rg.digit;
/*	
 Curve digitization package

	Copyright Renaud Gicquel 2008
	This document is licensed under CC BY-SA 4.0 (Attribution-ShareAlike 4.0 International)
	
*/
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.text.*;

/** Cette classe permet de crer un champ
* de saisie d'un double format selon la
* locale
* This class allows to create a field for
* entering a double formatted depending on the locale
*@author Renaud GICQUEL
**/
public class DoubleChamp extends javax.swing.JTextField
{

	protected double Value, minValue, maxValue;
	protected boolean lowerLimited,upperLimited;
    protected String nom;

	public DoubleChamp()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		Insets ins = getInsets();
		setSize(ins.left + ins.right + 100,ins.top + ins.bottom + 30);
	    //}}
		//{{REGISTER_LISTENERS

		//}}
    }

/**
 * Constructeur
 * @param d double valeur initiale
 * <p>initial value
 * @param dec int nombre de dcimales affiches
 * <p>number of decimal digits displayed
 */
 public DoubleChamp(double d, int dec)
	{
	    this();
	    lowerLimited=false;
	    upperLimited=false;
		setText(aff_d_univ(d,dec,Locale.getDefault()));
}
	//{{DECLARE_CONTROLS
	//}}

/**
 * accesseur de modification
 * modification accessor
 * @param d double valeur initiale
 * <p>initial value
 * @param dec int nombre de dcimales affiches
 * <p>number of decimal digits displayed
 */
	public void setValue(double d)
	{
    setValue(d,10);
    }

/**
 * accesseur de modification
 * modification accessor
 * @param d double valeur initiale
 * <p>initial value
 * @param dec int nombre de dcimales affiches
 * <p>number of decimal digits displayed
 */
	public void setValue(double d,int dec)
	{
	    boolean test=true;
	    String mess;
        String leType="";//getParent().toString();
  /*      if(getParent() instanceof rg.thopt.Primtype){
            rg.thopt.Primtype pt=(rg.thopt.Primtype)getParent();
            leType="/"+pt.getName();
        }*/
	    if(lowerLimited && (d<minValue)){//
		test=false;
		mess="inf_limite"+this.getNom()+leType;//+this.getParent().get;//   .getName();//.ge  .toString();
    	JOptionPane.showMessageDialog(null,mess);
    	this.Value=minValue;
		}
	    if(upperLimited && (d>maxValue)){//
		test=false;
		mess="sup_limite"+this.getNom()+leType;//.ge  .toString();
    	JOptionPane.showMessageDialog(null,mess);
    	this.Value=maxValue;
		}

		if(test){
			this.Value = d;
			 setText(aff_d_univ(d,dec,Locale.getDefault()));
		}

	}
	public void setLimits(String nom,double min, double max){
	  setLowerLimited(true);
      setUpperLimited(true);
      setNom(nom);
      setMinValue(min);
      setMaxValue(max);
	}
	public void setMin(String nom,double min){
	  setLowerLimited(true);
      setNom(nom);
      setMinValue(min);
	}
	public void setMax(String nom, double max){
      setUpperLimited(true);
      setNom(nom);
      setMaxValue(max);
	}


	public void setMinValue(double d)
	{
			this.minValue = d;
	}
	public void setMaxValue(double d)
	{
			this.maxValue = d;
	}
	public void setLowerLimited(boolean b)
	{
			lowerLimited = b;
	}
	public void setUpperLimited(boolean b)
	{
			upperLimited = b;
	}
	public void setNom(String s)
	{
			this.nom = s;
    }
	public String getNom()
	{
			return nom;
    }
/**
 * accesseur de consultation
 * renvoie la valeur saisie
 */

	public double getValue()
	{
	    String mess;
		this.Value=lit_d(getText().trim(),Locale.getDefault());

	    if(lowerLimited && (Value<minValue)){//
		    mess="inf_limite "+this.getNom();//+this.getParent().get;//   .getName();//.ge  .toString();
    	    JOptionPane.showMessageDialog(null,mess);
    	    setValue(minValue);
    	    return minValue;
		}
	    if(upperLimited && (Value>maxValue)){//
		    mess="sup_limite"+this.getNom();//.ge  .toString();
    	    JOptionPane.showMessageDialog(null,mess);
    	    setValue(maxValue);
    	    return maxValue;
		}
    	setValue(this.Value);//modRG 29/10
		return this.Value;
	}
	public double getMinValue()
	{
		return	this.minValue;
	}
	public double getMaxValue()
	{
		return	this.maxValue;
	}
    /**
	* mthode de classe de conversion de chane
	* de caractre  double (pour lecture  l'cran)
	* conversion from String to double
	*/
	public static double lit_d(String s,Locale loc ){
	    NumberFormat form = NumberFormat.getInstance(loc);
	    Number res;
	    ParsePosition pp=new ParsePosition(0);
	    res=form.parse(s,pp);
	    int i=pp.getIndex();
	    if(i<s.length()){
	        String mess= "format_nombre "+s;
	        mess=mess+" format_inval "+res;
            JOptionPane.showMessageDialog(null, mess);
        }
	    if(res!=null)return res.doubleValue();
	    else return 0.;
	}//fin de lit_d

	/**
	* mthode de classe d'affichage d'un double sous
	* forme de chane de caractre avec dec dcimales
	* et avec affichage rgional
	* locale depending conversion from double to String
	* with dec decimal digits
	*
	*/
	private static String aff_d_univ(double d, int dec, Locale loc)
	{
	if(Math.abs(d)<0.00000001)return "0";//modRG 08/07

	Double DD;
	double mant = mantis(d);
	int exp=expos(d);
	int decmin;//nombre minimal de dcimales
	if(exp<0)decmin=-exp;
	else decmin=0;
	int decmax=decmin+dec;//nombre maximal de dcimales
	double d1=d+0.5/Math.pow(10,decmax);
	double i=Math.floor(d1*Math.pow(10,decmax));
	d1=i/Math.pow(10,decmax);
	DD=new Double(d1);
	String r;
	NumberFormat form = NumberFormat.getInstance(loc);
	form.setMinimumFractionDigits(decmin);
	form.setMaximumFractionDigits(decmax);
	r=form.format(DD.doubleValue());
	return r;
	}//fin de aff_d_univ
/**
 * Calcule la mantisse d'un double
 * calculates the mantissa of a double
 *
 * @param d the double
 * @return java.lang.String
 */
public static double mantis(double d) {
    if(d==0.)return 0;
    int exp=expos(d);
	double mant;
	mant=d/Math.pow(10,exp);
	return mant;
}
/**
 * Calcule l'exposant d'un double
 * calculates the exponent of a double
 *
 * @param d the double
 * @return java.lang.String
 */
public static int expos(double d) {
    if(d==0.)return 1;
	double d2;
	int exp;
	d2=Math.abs(d);
	exp=(int)(Math.floor(Math.log(d2)/Math.log(10)));
	d2=d2/Math.pow(10,exp);
	if(d2>=10)exp=exp+1;
	return exp;
}

	static public void main(String args[])
	{
		class DriverFrame extends java.awt.Frame {
			public DriverFrame() {
				addWindowListener(new java.awt.event.WindowAdapter() {
					public void windowClosing(java.awt.event.WindowEvent event)
					{
						dispose();	  // free the system resources
						System.exit(0); // close the application
					}
				});
				this.setLayout(null);
				this.add(new DoubleChamp());
			}
		}

	}


}