package rg.digit;
/*	
 Curve digitization package

	Copyright Renaud Gicquel 2008
	This document is licensed under CC BY-SA 4.0 (Attribution-ShareAlike 4.0 International)
	
*/

import java.awt.*;
import javax.swing.*;

public class JAboutDialog extends javax.swing.JDialog
{
	public JAboutDialog(Frame parentFrame)
	{
		super(parentFrame);
		setTitle("Digitizer - About");
		setModal(true);
		getContentPane().setLayout(null);
		setSize(300,200);
		setVisible(false);
		okButton.setText("OK");
		okButton.setActionCommand("OK");
		okButton.setOpaque(false);
		okButton.setMnemonic((int)'O');
		getContentPane().add(okButton);
		okButton.setBounds(230,120,51,25);
		getContentPane().add(aboutLabel);
		aboutLabel.setBounds(0,0,280,100);
		
		aboutLabel.setLineWrap(true); 
	    aboutLabel.setWrapStyleWord(true); 
		SwingUtilities.invokeLater(new Runnable() {
		    public void run() {
				aboutLabel.setText("Curve digitization package\nVersion 1.0\n"
		    			+ "Copyright Renaud Gicquel 2008\n"
		    			+"This application is licensed under CC BY-SA 4.0"
		    			+"\n(Attribution-ShareAlike 4.0 International)");
		    }
		});

		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		//}}
	}

	public void setVisible(boolean b)
	{
	    if (b)
	    {
    		Rectangle bounds = (getParent()).getBounds();
    		Dimension size = getSize();
    		setLocation(bounds.x + (bounds.width - size.width)/2,
    			        bounds.y + (bounds.height - size.height)/2);
	    }

		super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JButton okButton = new javax.swing.JButton();
	javax.swing.JTextArea aboutLabel = new javax.swing.JTextArea();
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == JAboutDialog.this)
				jAboutDialog_windowClosing(event);
		}
	}

	void jAboutDialog_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.

		jAboutDialog_windowClosing_Interaction1(event);
	}

	void jAboutDialog_windowClosing_Interaction1(java.awt.event.WindowEvent event) {
		try {
			// JAboutDialog Hide the JAboutDialog
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_actionPerformed(event);
		}
	}

	void okButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		okButton_actionPerformed_Interaction1(event);
	}

	void okButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			// JAboutDialog Hide the JAboutDialog
			this.setVisible(false);
		} catch (Exception e) {
		}
	}
}