package rg.digit;
/*	
 Curve digitization package

	Copyright Renaud Gicquel 2008
	This document is licensed under CC BY-SA 4.0 (Attribution-ShareAlike 4.0 International)
	
*/
import java.awt.*;
import java.io.*;
import javax.swing.*;

public class JFrame1 extends javax.swing.JFrame

{
    Digitaliseur dig;
	public JFrame1()
	{
		//{{INIT_CONTROLS
		setJMenuBar(JMenuBar1);
		setTitle("Curve Digitizer");
		setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout(0,0));
		setSize(773,544);
		setVisible(false);
		JPanel2.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		getContentPane().add("North", JPanel2);
		JPanel2.setBounds(0,0,773,0);
		JPanel1.setLayout(null);
		getContentPane().add("Center", JPanel1);
		JPanel1.setBounds(0,0,773,544);
		//$$ JMenuBar1.move(0,0);
		JMenu1.setText("Digitization");
		JMenu1.setActionCommand("Digitization");
		JMenuBar1.add(JMenu1);
		JMenuItem1.setText("Digitize");
		JMenuItem1.setActionCommand("Digitize");
		JMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, Event.CTRL_MASK));
		JMenu1.add(JMenuItem1);
		JMenuItem3.setText("Quit");
		JMenuItem3.setActionCommand("Quit");
		JMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, Event.CTRL_MASK));
		JMenu1.add(JMenuItem3);
		helpMenu.setText("Help");
		helpMenu.setActionCommand("Help");
		helpMenu.setMnemonic((int)'H');
		JMenuBar1.add(helpMenu);
		aboutItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
		aboutItem.setText("About...");
		aboutItem.setActionCommand("About...");
		aboutItem.setMnemonic((int)'A');
		helpMenu.add(aboutItem);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		aboutItem.addActionListener(lSymAction);
		JMenuItem1.addActionListener(lSymAction);
		JMenuItem3.addActionListener(lSymAction);
		//}}
	    try{
	        File fich = new File("output.txt");
	        fich.delete();
	        fich= new File("error.txt");
	        fich.delete();
        }
        catch(SecurityException sexception){
            sexception.printStackTrace();
	        String msg = "Error deleting output or error file. Check your security privileges";
	   //     msg=msg+"\nor install the Thermoptim security access pack.";
	        JOptionPane.showMessageDialog(new Frame(), msg);
        }
	    try{
            System.setOut(new PrintStream(new FileOutputStream("output.txt", true)));
        }
        catch(IOException ioexception){
            ioexception.printStackTrace();
        }
        try{
            System.setErr(new PrintStream(new FileOutputStream("error.txt", true)));
        }
        catch(IOException ioexception1){
            ioexception1.printStackTrace();
        }
	}

    /**
     * Creates a new instance of JFrame1 with the given title.
     * @param sTitle the title for the new frame.
     * @see #JFrame1()
     */
	public JFrame1(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	/**
	 * The entry point for this application.
	 * Sets the Look and Feel to the System Look and Feel.
	 * Creates a new JFrame1 and makes it visible.
	 */
	static public void main(String args[])
	{
		try {
		    // Add the following code if you want the Look and Feel
		    // to be set to the Look and Feel of the native system.

			//Create a new instance of our application's frame, and make it visible.
			(new JFrame1()).setVisible(true);
		}
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}

    /**
     * Notifies this component that it has been added to a container
     * This method should be called by <code>Container.add</code>, and
     * not by user code directly.
     * Overridden here to adjust the size of the frame if needed.
     * @see java.awt.Container#removeNotify
     */
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
		    menuBarHeight = menuBar.getPreferredSize().height;
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JMenuBar JMenuBar1 = new javax.swing.JMenuBar();
	javax.swing.JMenu JMenu1 = new javax.swing.JMenu();
	javax.swing.JMenuItem JMenuItem1 = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItem3 = new javax.swing.JMenuItem();
	javax.swing.JMenu helpMenu = new javax.swing.JMenu();
	javax.swing.JMenuItem aboutItem = new javax.swing.JMenuItem();
	//}}

	//{{DECLARE_MENUS
	//}}

	void exitApplication()
	{
		try {
	    	// Beep
	    	Toolkit.getDefaultToolkit().beep();
	    	// Show a confirmation dialog
	    	int reply = JOptionPane.showConfirmDialog(this,
	    	                                          "Do you really want to exit?",
	    	                                          "Digitizer - Exit" ,
	    	                                          JOptionPane.YES_NO_OPTION,
	    	                                          JOptionPane.QUESTION_MESSAGE);
			// If the confirmation was affirmative, handle exiting.
			if (reply == JOptionPane.YES_OPTION)
			{
		    	this.setVisible(false);    // hide the Frame
		    	this.dispose();            // free the system resources
		    	System.exit(0);            // close the application
			}
		} catch (Exception e) {
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == JFrame1.this)
				JFrame1_windowClosing(event);
		}
	}

	void JFrame1_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.

		JFrame1_windowClosing_Interaction1(event);
	}

	void JFrame1_windowClosing_Interaction1(java.awt.event.WindowEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == aboutItem)
				aboutItem_actionPerformed(event);
			if (object == JMenuItem1)
				JMenuItem1_actionPerformed(event);
			else if (object == JMenuItem3)
				JMenuItem3_actionPerformed(event);
		}
	}

	void aboutItem_actionPerformed(java.awt.event.ActionEvent event)
	{
		try {
		{
			JAboutDialog JAboutDialog1 = new JAboutDialog(this);
			JAboutDialog1.setModal(true);
			JAboutDialog1.setVisible(true);
		}
		} catch (Exception e) {
		}
	}

	void JMenuItem1_actionPerformed(java.awt.event.ActionEvent event)
	{
		dig=new Digitaliseur();
		dig.setVisible(true);

	}

	void JMenuItem3_actionPerformed(java.awt.event.ActionEvent event)
	{
        exitApplication();
	}
}
